-- Most popular file latest 30 min

select
	count(hl.fileservedid) as "Count",
	'http://' || hostname || path || query as "30 most popular URL's last 120 minutes"
from
	httplog hl, 
	hostname hn,
	path p,
	query q
where 
	hitDateTime+'120 min'::interval>'now'
	and hl.servernameid = hn.hostnameid
	and hl.pathid = p.pathid
	and hl.queryid = q.queryid
group by
	hn.hostname,
	p.path,
	q.query
order by
	"Count"
	desc
limit 30
;
